﻿using AutoMapper;

using GamesStore.Entities;
using GamesStore.Web.Models.Games;
using GamesStore.Web.Models.Studios.Index;

namespace GamesStore.Web
{
    public static class MappingConfig
    {
        public static void RegisterMappings()
        {
            Mapper.CreateMap<Game, GameWithoutIdViewModel>();

            Mapper.CreateMap<GameWithoutIdViewModel, Game>();

            Mapper.CreateMap<Game, GameViewModel>();

            Mapper.CreateMap<GameViewModel, Game>();

            Mapper.CreateMap<Developer, DeveloperViewModel>()
                .ForMember(view => view.FullName, options => options.MapFrom(developer => developer.Name));

            Mapper.CreateMap<Studio, StudioViewModel>()
                .ConstructUsing((Studio view) => new StudioViewModel())
                .ForMember(view => view.FoundationYear, options => options.MapFrom(studio => studio.FoundationYear.ToString("0000")));
        }
    }
}