﻿using System;
using System.Collections.Generic;
using GamesStore.Web.Models.Games;

namespace GamesStore.Web.Models.Studios.Index
{
    public class StudioViewModel
    {
        private Func<IEnumerable<GameViewModel>> gamesLazyInitializer;
        private Func<IEnumerable<DeveloperViewModel>> developersLazyInitializer;

        private IEnumerable<GameViewModel> games;
        private IEnumerable<DeveloperViewModel> developers;

        public StudioViewModel() { }

        public StudioViewModel(Func<IEnumerable<GameViewModel>> gamesInitializer, Func<IEnumerable<DeveloperViewModel>> developersInitializer)
        {
            gamesLazyInitializer = gamesInitializer;
            developersLazyInitializer = developersInitializer;
        }

        public Guid Id { get; set; }

        public string Name { get; set; }

        public string FoundationYear { get; set; }

        public IEnumerable<GameViewModel> Games
        {
            get
            {
                if (games == null && gamesLazyInitializer != null)
                {
                    games = gamesLazyInitializer();
                    gamesLazyInitializer = null;
                }
                return games;

            }
            set
            {
                games = value;
            }
        }

        public IEnumerable<DeveloperViewModel> Developers
        {
            get
            {
                if (developers == null && developersLazyInitializer != null)
                {
                    developers = developersLazyInitializer();
                    developersLazyInitializer = null;
                }
                return developers;
            }
            set
            {
                developers = value;
            }
        }
    }
}