﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Web.Mvc;
using GamesStore.Web.Models.Studios.Index;

namespace GamesStore.Web.Models.Studios
{
    public class IndexViewModel
    {
        private int logCounter = 0;

        private StringBuilder builder { get; set; } = new StringBuilder();

        public DateTime OperationStarted { get; set; }

        public IEnumerable<StudioViewModel> Studios { get; set; }

        public TimeSpan GetOperationDuration()
        {
            return DateTime.Now - OperationStarted;
        }

        public void LogText(string text)
        {
            if (String.IsNullOrWhiteSpace(text))
                return;

            logCounter++;

            var header = new TagBuilder("h6");
            header.SetInnerText($"Item #{logCounter}:");

            var message = new TagBuilder("p");
            message.SetInnerText(text);

            builder.AppendLine(header.ToString());
            builder.AppendLine(message.ToString());
            builder.AppendLine();
        }

        public MvcHtmlString GetLoggedTexts()
        {
            return new MvcHtmlString(builder.ToString());
        }
    }
}